<template>
  <section>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Actualizar Video</span>
        </div>
        <div class="navbar-end">
          <div class="navbar-item">
            <div class="field">
              <b-switch type="is-twitter">Salir al guardar</b-switch>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
        <form @submit.prevent="validate">
          <div class="columns is-multiline">
            <div class="column is-6">
              <b-field
                label="Link*"
                :type="{ 'is-danger': errors.has('link') }"
                :message="errors.first('link')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.liveUrl"
                  name="link"
                  data-vv-as="Link"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
        
          </div>
          <nav class="level">
            <!-- Left side -->
            <div class="level-left">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-light"
                  @click="clean"
                  icon-right="eraser"
                  >Limpiar</b-button
                >
              </p>
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-danger"
                  @click="cancel"
                  icon-right="cancel"
                  >Cancelar</b-button
                >
              </p>
            </div>

            <!-- Right side -->
            <div class="level-right">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-primary"
                  native-type="submit"
                  icon-right="content-save"
                  >Guardar</b-button
                >
              </p>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </section>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import BaseVue from "../../core/BaseVue";
import { Utils } from "@/core/Utils";
import StreamVideoService from "@/services/streamVideoService";
import StreamVideoModel from "@/models/StreamVideo.model";

@Component
export default class StreamVideoEdit extends BaseVue {
  model: StreamVideoModel;
  streamVideoService: StreamVideoService = new StreamVideoService();
  streamVideoId: number = 0;
  isLoading: boolean = false;
  constructor() {
    super();
    this.model = new StreamVideoModel();
    this.streamVideoId = Number(this.$route.params.id);
  }

  created() {
    this.getPlayerById();
  }

  getPlayerById() {
    this.isLoading = true;
    this.streamVideoService
      .getStreamVideoById(this.streamVideoId)
      .then((resp) => {
        Utils.mapToObject(resp.data, this.model);
      })
      .finally(() => {
        this.isLoading = false;
      });
  }

  public cancel() {
    this.$router.push(`${this.$router.currentRoute.path.split("/editar")[0]}`);
  }

  public async validate() {
    try {
      this.isLoading = true;
      var result = await this.$validator.validateAll();
      if (result) {
        this.model.playerOneId = Number(this.model.playerOneId);
        this.model.playerTwoId= Number(this.model.playerTwoId);
        await this.streamVideoService
          .updateStreamVideo(this.streamVideoId, this.model)
          .then((resp) => {
            this.operationSuccess();
          })
          .finally(() => {
            this.isLoading = false;
            this.$router.push(
              `${this.$router.currentRoute.path.split("/editar")[0]}`
            );
          });

        return;
      }
      throw this.$validator.errors.items.map((e) => e.msg);
    } catch (errors) {
      this.isLoading = false;
      this.operationFailedErrors(errors as any);
    }
  }
}
</script>
